import type { ReactNode } from 'react';
import type { StyleProp, ViewStyle } from 'react-native';
export declare type TextRenderer = (token: string, index: number) => ReactNode;
export declare type TextAndRenderer = [string, TextRenderer];
export declare type TextAndRendererList = TextAndRenderer[];
export declare type TokensAndRenderer = [string[], TextRenderer];
export declare type LineBreakParser = (textAndRenderer: TextAndRenderer) => TextAndRenderer | TextAndRendererList;
export declare type Grouper = (acc: TextAndRendererList, textOrRenderer: string | TextRenderer) => TextAndRendererList;
export declare type WhiteSpateParser = (textAndRenderer: TextAndRenderer) => TokensAndRenderer;
export interface WordWrapTextProp {
    textAndRendererList: TextAndRendererList;
    containerStyle: StyleProp<ViewStyle>;
}
